<script>
    import { layoutData, layoutURL, subplotLayouts } from './stores/layoutStore.js';
    import { hapiServerInfoCadences, dataProductInfo } from './stores/dataProductStore.js';
    import GlobalSettings from './form_sections/GlobalSettings.svelte';
    import SubplotForm from './form_sections/SubplotForm.svelte';
    // import RangeSliderMinMax from './form_components/RangeSliderMinMax.svelte';
    import SelectInput from './form_components/SelectInput.svelte';

    let formVisible = false;

    const reload_all = function() {
        subplotLayouts.reload();
        dataProductInfo.reload();
    }

</script>
<div class="layoutform" class:formVisible>
{#if (!formVisible)}
    <div style="height: 100%;" on:click={()=>{formVisible=true}}>
    <svg  xmlns="http://www.w3.org/2000/svg" height="10" width="10"><path transform="scale(0.5)" d="M3.375 15.188q-.396 0-.698-.292-.302-.292-.302-.688 0-.416.302-.708t.698-.292h13.25q.396 0 .698.292.302.292.302.708 0 .396-.302.688-.302.292-.698.292Zm0-4.188q-.396 0-.698-.302-.302-.302-.302-.698 0-.396.302-.698Q2.979 9 3.375 9h13.25q.396 0 .698.302.302.302.302.698 0 .396-.302.698-.302.302-.698.302Zm0-4.208q-.396 0-.698-.292-.302-.292-.302-.708 0-.396.302-.688.302-.292.698-.292h13.25q.396 0 .698.292.302.292.302.688 0 .416-.302.708t-.698.292Z"/></svg></div>
{:else}
    <svg on:click={()=>{formVisible=false}} xmlns="http://www.w3.org/2000/svg" height="20" width="20"><path d="m10 11.396-3.938 3.937q-.291.292-.687.282-.396-.011-.687-.303-.292-.291-.292-.697 0-.407.292-.698L8.604 10 4.667 6.062q-.292-.291-.282-.697.011-.407.303-.698.291-.292.697-.292.407 0 .698.292L10 8.604l3.938-3.937q.291-.292.697-.292.407 0 .698.292.292.291.292.698 0 .406-.292.697L11.396 10l3.937 3.938q.292.291.292.687 0 .396-.292.687-.291.292-.698.292-.406 0-.697-.292Z"/></svg>
    <div style="width: 330px;">
    <SelectInput titleText="Layout preset" bind:value={$layoutURL} onchange={reload_all()}>
        <option value='/static/json/layout.json'>Real-time SWPC</option>
        <option value='/static/json/layout_enlil.json' selected>Solar wind at L1 with ENLIL model</option>
        <option value='/static/json/layout_imagetest.json'>Image Test</option>
        <option value='/static/json/layout_swarm.json'>Swarm C Ne - image and line graphs</option>
        <option value='/static/json/layout_swarm_rho.json'>Swarm C rho - image and line graphs</option>
        <option value='/static/json/layout_swarm_mid_term_case_studies.json'>Swarm C Ne and rho - line graphs only</option>
        <option value='/static/json/layout_swarm_ipir_wam_ipe.json'>Swarm C IPIR</option>
        <option value='/static/json/layout_starlink.json'>Starlink case study</option>
        <option value='/static/json/layout_icao.json'>ICAO advisories</option>
        <option value='/static/json/layout_ace.json'>ACE</option>
        <option value='/static/json/layout_dscovr.json'>DSCOVR</option>
        <option value='/static/json/layout_magnetosphere.json'>SuperMAG</option>
        <option value='/static/json/layout_omni.json'>CDAWeb OMNI Test</option>
        <option value='/static/json/layout_longterm.json'>Historical observations</option>
        <option value='/static/json/layout_colormapped_symbols.json' selected>Color-mapped symbols test</option>
        <option value='/static/json/layout_intermagnet.json' selected>Intermagnet</option>
    </SelectInput>

    {#if $layoutData.subplots}
        <GlobalSettings/>
        {#each $layoutData.subplots as subplot, subplot_index}
            <SubplotForm {subplot} {subplot_index}/>
        {/each}
    {/if} <!-- Layout data available -->
    </div>
{/if} <!-- Form visible -->
</div>
<style>
    .layoutform {
        width: 10px;
        margin: 0;
        padding: 2px 2px;
        text-align: right;
        background-color: #f5f5f5;
        transition: width 0.35s;
    }

    .formVisible {
        width: 330px;
        margin: 0;
        padding: 5px 20px 5px 15px;
        overflow: auto;
        background-color: #f0f0f0;
    }

    div.layoutform h3{
        text-align: left;
        font-size: 12pt;
    }

    div.layoutform h4{
        text-align: left;
        font-size: 10pt;
    }

    label{
        display: inline;
        font-size: 10pt;
        margin: 2px;
        padding: 0px;
    }
</style>
